package graph

// This file will be automatically regenerated based on the schema, any resolver implementations
// will be copied through when generating and any unknown code will be moved to the end.
// Code generated by github.com/99designs/gqlgen version v0.17.24

import (
	"context"
	"encoding/json"
	"test3/graph/model"
	"test3/graph/utils"
	"test3/internal/buildings"
	"test3/internal/users"
)

// Login is the resolver for the login field.
func (r *mutationResolver) Login(ctx context.Context, input model.Login) (*model.Token, error) {
	token, err := users.Login(input)
	var result = &model.Token{Value: token.Value, ExpiredAt: token.ExpiredAt.String()}
	return result, err
}

// Buildings is the resolver for the buildings field.
func (r *queryResolver) Buildings(ctx context.Context, keyword string, page int, pageSize int) (*model.Buildings, error) {
	var items []*model.Building

	tokenStr, ok := ctx.Value("JWT").(string)
	if ok {
		isValid, err := utils.ValidateJWT(tokenStr)
		if !isValid {
			var result = &model.Buildings{Items: items, Total: 0, Size: 0, Page: page}
			return result, err
		}
	}

	rows, total := buildings.GetAll(keyword, page, pageSize)

	for _, building := range rows {
		var gfa []*model.BuildingGfa
		json.Unmarshal([]byte(building.BuildingGfa), &gfa)

		var rating []*model.EnergyStarRating
		json.Unmarshal([]byte(building.EnergyStarRating), &rating)

		var mertics []*model.Metrics
		json.Unmarshal([]byte(building.Metrics), &mertics)

		items = append(
			items,
			&model.Building{
				OSEBuildingID:                 building.OSEBuildingID,
				DataYear:                      building.DataYear,
				BuildingType:                  building.BuildingType,
				PrimaryPropertyType:           building.PrimaryPropertyType,
				PropertyName:                  building.PropertyName,
				Address:                       building.Address,
				City:                          building.City,
				State:                         building.State,
				ZipCode:                       building.ZipCode,
				TaxParcelIdentificationNumber: building.TaxParcelIdentificationNumber,
				CouncilDistrictCode:           building.CouncilDistrictCode,
				Latitude:                      building.Latitude,
				Longitude:                     building.Longitude,
				YearBuilt:                     building.YearBuilt,
				NumberofBuildings:             building.NumberofBuildings,
				NumberofFloors:                building.NumberofFloors,
				BuildingGfa:                   gfa,
				EnergyStarRating:              rating,
				Metrics:                       mertics,
			},
		)
	}

	var size int = len(items)
	var result = &model.Buildings{Items: items, Page: page, Total: total, Size: size}

	return result, nil
}

// AvgEui is the resolver for the avgEUI field.
func (r *queryResolver) AvgEui(ctx context.Context) ([]*model.AvgEui, error) {
	var items []*model.AvgEui

	tokenStr, ok := ctx.Value("JWT").(string)
	if ok {
		isValid, err := utils.ValidateJWT(tokenStr)
		if !isValid {
			return items, err
		}
	}

	rows := buildings.GetAvgEUI()
	for _, building := range rows {
		items = append(
			items,
			&model.AvgEui{
				PrimaryPropertyType: building.PrimaryPropertyType,
				Eui:                 building.Eui,
			},
		)
	}

	return items, nil
}

// Mutation returns MutationResolver implementation.
func (r *Resolver) Mutation() MutationResolver { return &mutationResolver{r} }

// Query returns QueryResolver implementation.
func (r *Resolver) Query() QueryResolver { return &queryResolver{r} }

type mutationResolver struct{ *Resolver }
type queryResolver struct{ *Resolver }
